# ARST打卡第91周[91/521]

<!--more-->

## Algorithm
[LeetCode/839_相似字符串组](https://github.com/wolfdan666/WolfEat3moreMeatEveryday/blob/9376e8c03a5f6e92ebe06d7b11bb191488021aa6/LeetCode/839_%E7%9B%B8%E4%BC%BC%E5%AD%97%E7%AC%A6%E4%B8%B2%E7%BB%84.cpp)

## Review
[SERIALIZATION (ENCODE/DECODE)](https://docs.ceph.com/en/latest/dev/encoding/)

## Tips
[Python结合OpenCV视频处理、逐帧修改图片](https://blog.csdn.net/weixin_42527719/article/details/85694544)

## Share
### Ceph的encoding宏定义妙用
1. 宏定义do_while(false)套娃
```cpp
#define ENCODE_START(A) \
    int a = A;      \
    printf("hello a=%d\n", a); \
    do {

// 这中间还套娃了很多层do,while,这是我没有想到了

#define DECODE_FINISH() \
    } while(false);

int main() {
    cout << "hello world" << endl;
    ENCODE_START(100)
    DECODE_FINISH()
    return 0;
}
```

2. 震惊宏定义缩短定义的方法
```cpp
// -----------------------------------
// int types

#define WRITE_INTTYPE_ENCODER(type, etype)				\
  inline void encode(type v, bufferlist& bl, uint64_t features=0) {	\
    ceph_##etype e;					                \
    e = v;                                                              \
    encode_raw(e, bl);							\
  }									\
  inline void decode(type &v, bufferlist::iterator& p) {		\
    ceph_##etype e;							\
    decode_raw(e, p);							\
    v = e;								\
  }

WRITE_INTTYPE_ENCODER(uint64_t, le64)
WRITE_INTTYPE_ENCODER(int64_t, le64)
WRITE_INTTYPE_ENCODER(uint32_t, le32)
WRITE_INTTYPE_ENCODER(int32_t, le32)
WRITE_INTTYPE_ENCODER(uint16_t, le16)
WRITE_INTTYPE_ENCODER(int16_t, le16)
```


